"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var deck_1 = require("../src/deck");
var card_1 = require("../src/card");
var events_1 = require("../src/events");
var MAX_NO_OF_CARDS = 54;
describe("Deck", function () {
    var deck = new deck_1.default({
        emitter: new events_1.EventEmitter()
    });
    it("should have cards array", function () {
        chai_1.assert.isArray(deck.cards);
    });
    describe("Deck.prototype.cards", function () {
        describe("length", function () {
            it("should be ".concat(MAX_NO_OF_CARDS), function () {
                chai_1.assert.equal(deck.cards.length, MAX_NO_OF_CARDS);
            });
        });
        describe("shuffle", function () {
            describe("length", function () {
                it("should be ".concat(MAX_NO_OF_CARDS), function () {
                    chai_1.assert.equal(deck.shuffle().length, MAX_NO_OF_CARDS);
                });
            });
            it("should have every card", function () {
                deck.shuffle().forEach(function (shuffleCard) {
                    var card = deck.cards.find(function (card) {
                        return (card.shape === shuffleCard.shape &&
                            card.value === shuffleCard.value);
                    });
                    chai_1.assert.isDefined(card);
                });
            });
        });
        it("should have .shuffle()", function () {
            chai_1.assert.typeOf(deck.shuffle, "function");
        });
        it("should have instances of Card", function () {
            deck.cards.forEach(function (card) { return chai_1.assert.instanceOf(card, card_1.default); });
        });
    });
});
//# sourceMappingURL=deck.test.js.map